<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2007-2010 Rene Nitzsche (rene@system25.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_t3lib.'class.t3lib_svbase.php');
require_once(t3lib_extMgm::extPath('rn_base') . 'class.tx_rnbase.php');
tx_rnbase::load('tx_cfcleaguefe_sv2_PlayerStatistics');

/**
 * Service for scorer statistics
 * Since this list is similar to player statistics, it is based on that service. 
 * It simply modifies the result
 * 
 * @author Rene Nitzsche
 */
class tx_cfcleaguefe_sv2_ScorerStatistics extends tx_cfcleaguefe_sv2_PlayerStatistics {

  /**
   * Liefert die Liste der besten Torschützen
   *
   * @return array
   */
  public function getResult() {
    return $this->_findScorer($this->getPlayersArray());
  }

  /**
   * Sucht die besten Torschützen aus der Liste und liefert sie sortiert in einem Array zurück
   * @return Array mit den Datensätzen der Torschützen
   */
  private function _findScorer(&$playerData) {
    $ret = array();
    foreach($playerData As $playerStats) {
      if(intval($playerStats['goals_all']) > 0) {
        $ret[] = $playerStats;
      }
    }
    usort($ret, 'cmpScorer');
    return $ret;
  }
}

function cmpScorer($a, $b) {
  $goal1 = $a['goals_all'];
  $goal2 = $b['goals_all'];

  return ($goal1 == $goal2) ? 0 : ($goal1 < $goal2) ? 1 : -1;
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cfc_league_fe/sv2/class.tx_cfcleaguefe_sv2_ScorerStatistics.php']) {
  include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cfc_league_fe/sv2/class.tx_cfcleaguefe_sv2_ScorerStatistics.php']);
}

?>